/*
 Attacking commercial encryption
 by Joel R. Voss
 Jan 26, 2006
 */

/*
1) Generate pseudo-random 128-bit RC4 key (8 bytes).
2) Store 128 keys (1MB) in memory.
3) Save keys to hard drive.
4) Repeat.
5) ...
6) Profit!
*/

#include <openssl/rc4.h>

/*
The problem with this is that RC4 keys are just 8 bytes of data.
What would be useful would be to generate 128-bit key pairs, so that whenever 
I came across the public key, I could grab the private key.

What I can do with RC4, is to encrypt something with RC4 that will be the 
public key, then I can say with confidence that I have the key when I see the 
encrypted data. That encrypted data should be something that is so common that 
it is absurd (GET / HTTP/1.1 ...). You would need to use the ssl protocol to 
understand what the most common packet consists of, then you can attack RC4.
If the creators of SSL were smart, there would be no common packet: each 
packet would have 8 bytes of garbage at the end. RC4 is a stream cipher. 
Will the start of the stream be the same at the N-byte level? Yeah. But that 
just means that the smart people designing SSL will put 8 random bytes at the 
start of the stream. Do they?
*/

void RC4_set_key(RC4_KEY *key, int len, const unsigned char *data);
void RC4(RC4_KEY *key, unsigned long len, const unsigned char *indata,
        unsigned char *outdata);


#include <openssl/rsa.h>

/*
RSA key pair attack.
The same above applies to RSA only much much more so.
RSA is a system of public/private keys, so generating the keypair requires no 
extra work of deciding what is the common data.
*/
RSA *RSA_generate_key(int num, unsigned long e,
           void (*callback)(int,int,void *), void *cb_arg);
