/*
 * check_tar
 * by Javantea aka Joel R. Voss
 * Jan 29, 2006
 * Check std input for tar-style printable+null data.
 */

#include "check_tar.h"

int check_tar_file(FILE *file)
{
	// Grab up to 256 bytes.
	char data[256];
	int size = fread(data, 1, 256, file);
	return check_tar(data, size);
}

int check_tar(const char *data, int size)
{
	int i;
	for(i = 0; i < size; i++)
	{
		// Ensure that all bytes are between 32 (<space>) 
		// and 127 (the one after tilde).
		if(data[i] != 0  && data[i] < 32) //|| data[i] > 127))
		{
			return 1;
		}
	}
	// If the size is zero or less then it's not a valid tar.
	if(size <= 0) return 2;
	// Return 0 only if all characters read have passed.
	return 0;
}

#ifdef __CHECK_TAR_SA__

int main(int argc, char **argv)
{
	// Return the output of check_tar()
	return check_tar_file(stdin);
}
#endif // __CHECK_TAR_SA__
